Subject: bug#3702: Emacs fails to respect the intent in `C-u C-u C-x C-s' of making a backup

From: Andrew Hyatt <[email-masked]>
Date: Fri, 17 Jun 2016 23:37:28 -0400

Sorry for the late reply on this one.  This problem still exists in
Emacs 25.  I agree that the current behavior doesn't match up with the
documentation.

This probably is fixable by adding another free variable set by
save-buffer and read in various functions, but there's a lot of those
kind of variables already - the logic here, IMHO, could use a rewrite to
make the interactions clear.  Maybe someone familiar with this code
might give their opinion.

Taylor R Campbell <[email-masked]> writes:

> Often, when saving a file, I want to make a backup.  The only way I
> know to express this intent is `C-u C-u C-x C-s'.  When I type `C-u
> C-u C-x C-s', I mean to tell Emacs:  `I want you to make a backup and
> then save this file.'  The documentation for the `save-buffer' command
> says:
>
>    Prefixed by two C-u's,
>     unconditionally makes the previous version into a backup file.
>     ^^^^^^^^^^^^^^^
> Unfortunately, Emacs fails to respect my intent in many circumstances.
> First, I set `version-control' to t in order to keep numbered backups.
> Then in order to make backups in directories such as /tmp, I set
> `backup-enable-predicate' to be a function that always returns t.
> Next, in order to make backups when `vc' is involved, I set
> `vc-make-backup-files' to t, which confused me because it didn't take
> effect immediately -- I had to reload all my buffers before it did.
> This is because some vc hook set another variable, `backup-inhibited',
> when I first loaded those buffers.
>
> There are plenty of other documented ways for arbitrary modes to
> interfere with my intent when I type `C-u C-u' -- there are several
> hooks that are run during `save-buffer' before `backup-buffer' and
> conditions under which backups will be made.  This contradicts the
> documentation of `save-buffer' which explicitly says that `C-u C-u'
> means a backup will be made *unconditionally*.  I don't mind that
> there may be various heuristics for choosing whether to make a backup
> file when the user has not indicated a preference either way (by
> typing `C-u 0' or `C-u C-u' or whatnot), but it is very frustrating
> when the documentation says `unconditionally' and the implementation
> has many documented ways to interfere and add conditions.  Of course,
> the documentation could simply omit the word `unconditionally', but I
> don't want that either -- I want it really to be unconditional (as far
> as the documented hooks in Emacs go; of course someone could redefine
> `save-buffer', but it's the documented hooks and conditions such as
> `backup-inhibited' that bother me).
>
> I am using
>
> GNU Emacs 22.2.1 (i386-apple-darwin8.11.1, GTK+ Version 2.10.13) of 2008-07-06 on Oberon.local.
>
> In my .emacs file, relevant to backups, I have
>
> (defun always-backup (filename) filename t)
> (setq-default backup-enable-predicate 'always-backup)
> (setq-default version-control t)
> (setq-default vc-make-backup-files t)
> (setq-default backup-inhibited nil)
> (setq-default make-backup-files t)